
package java.de.TimeSlice;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.security.*;

/**
 * @author      Burghard Grueter
 * @author      Johannes Schick
 * @version     1.0, 11/06/2000
 * @since       JDK1.2
 */

	/**
	 * class <pre>Controlpanel</pre> contains the
	 * button to add a task and to stop a task (is not yet implemented)
	 * it owns a <pre>TaskDialog</pre> to get input data. 
	 */
public class ControlPanel extends JPanel implements ActionListener  				
{


	/**
	 * constructor of GUI-class, nothing more
	 *
	 * @param   Owner  // instance of MainFrame
	 * @param   tmlTasks  // Listener to notify a Task to be added
	 */
    public ControlPanel(MainFrame Owner, ControlPanelListener tmlTasks) 
	{
        super();
		this.Owner = Owner;
		this.tmlTasks = tmlTasks;
		this.tDialog = new TaskDialog(Owner, "Daten eingeben","");
		this.buildGUI();

    }
	
	ControlPanelListener tmlTasks;
	MainFrame Owner;
	
    //{{DECLARE_CONTROLS
	TaskDialog tDialog;
	
    JButton jbTaskHinzufuegen;
    JLabel lbTimeSlice;
    JButton jbStop;
    //}}

	


	/**
	 * Push the button!
	 *
	 * @param   e  
	 */
   public void actionPerformed(ActionEvent e) 
    {

	  if (e.getSource()==jbTaskHinzufuegen)
	   	addTask(); 	
	     
/*	 not yet implemented  
	else
	    stopTask(); */
	   	
    } 
	

	/**
	 * adds a Task to the GUI by instantiating a <pre>Taskpanel</pre>
	 * and tells the <pre>ControlpanelListener</pre> to add
	 * the <pre>Task</pre>-Object got from <pre>tDialog</pre>
	 * several Exception have to be caught since it processes
	 * user input
	 */
	private void addTask() 
	{
		try
	  	{				 
			Task h = tDialog.getTaskData("","","");
			  	
	  	  	if (h!=null)
			{						
				TaskPanel neu = new TaskPanel(tmlTasks, h, tDialog);
				
			    h.addUpdateTaskListener(neu);
				
				tmlTasks.addTask(h);
				
				Owner.getContentPane().add(neu);
				Owner.pack();
				Owner.update(Owner.getGraphics());
	  	  	}	
		}
		catch(InvalidParameterException ipe) 
		{
			handleException(ipe);
		}
		catch(TaskNameAlreadyExist tnae)
		{
			handleException(tnae);
		}
		catch(NumberFormatException nfe)
		{
			handleException(nfe);
		}
			  
	}
	
    private void handleException(Exception e) 
	{
		JOptionPane.showMessageDialog(this, e, "Fehler", JOptionPane.ERROR_MESSAGE); 
   		addTask();
	}
	
	
	private void buildGUI() 
	{        
	   //{{INIT_CONTROLS
	    this.setBorder(BorderFactory.createEtchedBorder());
	    GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.insets = new Insets(4,4,4,4);
		this.setLayout(gridbag);
		
        this.lbTimeSlice=new JLabel("TimeSlice");
		gridbag.setConstraints(lbTimeSlice, c);
        this.add(lbTimeSlice);
		
        this.jbTaskHinzufuegen=new JButton("Task hinzufgen");
		gridbag.setConstraints(jbTaskHinzufuegen, c);
        this.add(jbTaskHinzufuegen);
		this.jbTaskHinzufuegen.addActionListener(this);
		
        this.jbStop=new JButton("Task stoppen");
		c.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(jbStop, c);
        this.add(jbStop);
		this.jbStop.addActionListener(this);
    }
}


