package java.de.TimeSlice;

/**
 * @author      Burghard Grueter
 * @author      Johannes Schick
 * @version     1.0, 11/06/2000
 * @since       JDK1.2
 */
	/**
	 * interface <pre>TimerListener</pre>
	 * is implemented by <pre>TaskManager</pre>
	 * with methods to be called by the <pre>TaskTimer</pre>	
	 */
	 
interface TimerListener
{

	/**
	 * is called by the Timer periodically (delay) to update
	 * the active Task (countdown the <pre>Restdauer</pre>)
	 *
	 * @param   delta  : time difference to last update by the timer 
	 */
	public void updateActiveTask(long delta);

	/**
	 * is called by the timer when the day changes
	 *
	 * @param   now  :current time in millisec of the <pre>epoch</pre>
	 */
	public void updateDayChange(long now);
}

